Index: /protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java	(revision 53)
+++ /protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java	(revision 1)
@@ -1,8 +1,5 @@
 package geniusweb.protocol.session;
 
-import java.util.ArrayList;
 import java.util.Collections;
-import java.util.HashMap;
-import java.util.HashSet;
 import java.util.LinkedList;
 import java.util.List;
@@ -13,29 +10,32 @@
 import geniusweb.progress.Progress;
 import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.partyconnection.ConnectionWithParties;
 import geniusweb.references.PartyWithProfile;
 
 /**
- * 
+ * The default current state of the session. immutable.
  */
-/**
- * 
- * The default current state of the session. immutable.
- * 
- * @param <P> the actual SessionState object
- * @param <S> the actual SessionSettings object
- */
-public abstract class DefaultSessionState<P extends DefaultSessionState<P, S>, S extends SessionSettings>
-		implements SessionState {
+public abstract class DefaultSessionState implements SessionState {
 	private final List<Action> actions;
 
-	private final List<PartyId> connections;
+	private final transient ConnectionWithParties connections;
 
 	private final Progress progress;
 
-	private final S settings;
+	private final SessionSettings settings;
 
 	private final ProtocolException error;
 
 	private final Map<PartyId, PartyWithProfile> partyprofiles;
+
+	// only for deserializer.
+	protected DefaultSessionState() {
+		actions = null;
+		connections = null;
+		progress = null;
+		settings = null;
+		partyprofiles = null;
+		error = null;
+	}
 
 	/**
@@ -57,66 +57,45 @@
 	 *                      {@link ProtocolException}s. All errors in our own
 	 *                      code are bugs (not ProtocolExceptions) and should
-	 *                      result in a throw and terminate the session.
-	 */
-	public DefaultSessionState(List<Action> actions, List<PartyId> conns,
-			Progress progr, S settings,
+	 *                      result in a throw.
+	 */
+	public DefaultSessionState(List<Action> actions,
+			ConnectionWithParties conns, Progress progr,
+			SessionSettings settings,
 			Map<PartyId, PartyWithProfile> partyprofiles, ProtocolException e) {
 		if (partyprofiles == null) {
-			this.partyprofiles = Collections.emptyMap();
+			partyprofiles = Collections.EMPTY_MAP;
+		}
+		if (conns == null) {
+			this.connections = new ConnectionWithParties(
+					Collections.EMPTY_LIST);
 		} else {
-			this.partyprofiles = new HashMap<>(partyprofiles);
-		}
-		if (conns == null) {
-			this.connections = Collections.emptyList();
-		} else {
-			this.connections = new LinkedList<>(conns);
+			this.connections = conns;
 		}
 		if (actions == null) {
 			this.actions = new LinkedList<>();
 		} else {
-			this.actions = new LinkedList<>(actions);
-		}
-
-		if (connections.size() != new HashSet<PartyId>(connections).size()) {
+			this.actions = actions;
+		}
+
+		if (!connections.allunique()) {
 			throw new IllegalArgumentException(
 					"There can not be multiple connections for a party:"
 							+ connections);
 		}
-		if (settings == null)
-			throw new IllegalArgumentException("Settings must be not null");
 		this.progress = progr;
 		this.settings = settings;
+		this.partyprofiles = partyprofiles;
 		this.error = e;
 	}
 
 	/**
-	 * Construct a new session state, where the DefaultSessionState changes
-	 * while the rest of the state remains unchanged. Notice the return type P.
-	 * 
-	 * @param actions1       the new {@link Action}s
-	 * @param conns          the new connected {@link PartyId}s
-	 * @param progress1      the new {@link Progress}
-	 * @param settings1      the new {@link SessionSettings}. Normally this is
-	 *                       constant during a session.
-	 * @param partyprofiles1 the new {@link PartyWithProfile}s for all parties.
-	 *                       Normally this remains constant during a session.
-	 * @param e              an error that occured that caused the session to
-	 *                       reach its terminated/final state. If an error does
-	 *                       not cause termination, only a warning should be
-	 *                       logged.
-	 * @return the new state of the derived sessionstate.
-	 */
-	abstract public P with(List<Action> actions1, List<PartyId> conns,
-			Progress progress1, S settings1,
-			Map<PartyId, PartyWithProfile> partyprofiles1, ProtocolException e);
-
-	/**
 	 * @return existing connections.
 	 */
-	public List<PartyId> getConnections() {
-		return Collections.unmodifiableList(connections);
-	}
-
-	/**
+	public ConnectionWithParties getConnections() {
+		return connections;
+	}
+
+	/**
+	 * @return
 	 * @return map with {@link PartyWithProfile} for the parties. May be an
 	 *         incomplete map, as more parties with their profiles may be set
@@ -124,5 +103,5 @@
 	 */
 	public Map<PartyId, PartyWithProfile> getPartyProfiles() {
-		return Collections.unmodifiableMap(partyprofiles);
+		return partyprofiles;
 	}
 
@@ -142,5 +121,5 @@
 
 	@Override
-	public S getSettings() {
+	public SessionSettings getSettings() {
 		return settings;
 	}
@@ -152,4 +131,5 @@
 	}
 
+	@Override
 	public ProtocolException getError() {
 		return error;
@@ -159,86 +139,6 @@
 	public String toString() {
 		return this.getClass().getSimpleName() + "[" + actions + ","
-				+ connections + "," + progress + "," + settings + "," + error;
-	}
-
-	public P withDeadlineReached() {
-		return with(actions, connections, progress, settings, partyprofiles,
-				error);
-	}
-
-	public P withoutParty(PartyId party) {
-		List<PartyId> newconn = new ArrayList<>(connections);
-		newconn.remove(party);
-		return with(actions, newconn, progress, settings, partyprofiles, error);
-	}
-
-	/**
-	 * 
-	 * @param e the error that occured
-	 * @return a new state with the error set/updated.
-	 */
-	public P with(ProtocolException e) {
-		return with(actions, connections, progress, settings, partyprofiles, e);
-	}
-
-	public P with(PartyId connection, PartyWithProfile partyprofile) {
-		List<PartyId> newconns = new ArrayList<>(getConnections());
-		newconns.add(connection);
-		Map<PartyId, PartyWithProfile> newprofiles = new HashMap<>(
-				getPartyProfiles());
-		newprofiles.put(connection, partyprofile);
-		return with(getActions(), newconns, getProgress(), getSettings(),
-				newprofiles, null);
-	}
-
-	/**
-	 * Sets the new progress for this session.
-	 * 
-	 * @param newprogress the new progress
-	 * @return new SAOPState with the progress set to new value
-	 */
-	public P with(Progress newprogress) {
-		if (newprogress == null) {
-			throw new IllegalArgumentException("newprogress must be not null");
-		}
-		return with(actions, connections, newprogress, settings, partyprofiles,
-				error);
-	}
-
-	/**
-	 * @param actor  the actor that did this action. Can be used to check if
-	 *               action is valid. NOTICE caller has to make sure the current
-	 *               state is not final.
-	 * @param action the action that was proposed by actor.
-	 * @return new SAOPState with the action added as last action.
-	 */
-
-	public P with(PartyId actor, Action action) {
-		String msg = checkAction(actor, action);
-		if (msg != null)
-			throw new IllegalArgumentException(msg);
-
-		List<Action> newactions = new LinkedList<>(getActions());
-		newactions.add(action);
-		return with(newactions, connections, progress, settings, partyprofiles,
-				error);
-	}
-
-	/**
-	 * 
-	 * @param actor  the known real actor that did this action
-	 * @param action an {@link Action}
-	 * @return null if action seems ok, or message explaining why not.
-	 */
-	public String checkAction(PartyId actor, Action action) {
-		if (actor == null) { // this is a bug
-			return "actor must not be null";
-		}
-		if (action == null) {
-			return "action is null";
-		}
-		if (!actor.equals(action.getActor()))
-			return "act contains wrong credentials: " + action;
-		return null;
+				+ connections + "," + progress + "," + settings + "," + error
+				+ "]";
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/SessionSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/SessionSettings.java	(revision 53)
+++ /protocol/src/main/java/geniusweb/protocol/session/SessionSettings.java	(revision 1)
@@ -6,10 +6,5 @@
 
 import geniusweb.protocol.NegoSettings;
-import geniusweb.protocol.session.amop.AMOPSettings;
-import geniusweb.protocol.session.learn.LearnSettings;
-import geniusweb.protocol.session.mopac.MOPACSettings;
-import geniusweb.protocol.session.mopac2.MOPAC2Settings;
 import geniusweb.protocol.session.saop.SAOPSettings;
-import geniusweb.protocol.session.shaop.SHAOPSettings;
 import geniusweb.references.PartyWithProfile;
 import tudelft.utilities.logging.Reporter;
@@ -18,51 +13,31 @@
  * interface for settings for session protocols. Immutable.
  */
-@JsonSubTypes({ @JsonSubTypes.Type(value = SAOPSettings.class),
-		@JsonSubTypes.Type(value = SHAOPSettings.class),
-		@JsonSubTypes.Type(value = AMOPSettings.class),
-		@JsonSubTypes.Type(value = MOPACSettings.class),
-		@JsonSubTypes.Type(value = MOPAC2Settings.class),
-		@JsonSubTypes.Type(value = LearnSettings.class) })
+@JsonSubTypes({ @JsonSubTypes.Type(value = SAOPSettings.class) })
+
 public interface SessionSettings extends NegoSettings {
 
 	/**
-	 * Get the {@link TeamInfo}s.
+	 * Get participants
 	 * 
 	 * @return list of {@link PartyWithProfile} items.
 	 */
-	List<TeamInfo> getTeams();
+	public List<PartyWithProfile> getParticipants();
 
 	/**
-	 * @return the size of each {@link TeamInfo}. Usually 1 (SAOP etc) or
-	 *         sometimes 2 (SHAOP). Used eg by tournament runner to determine
-	 *         proper team construction.
-	 */
-	Integer getTeamSize();
-
-	/**
-	 * Allows modification of SessionSettings to include a party. This is needed
-	 * for tournament auto-configuration of sessions.
+	 * Allows modification of SessionSettings to include a party. This is needed for
+	 * tournament auto-configuration of sessions.
 	 * 
-	 * @param partyprofteam the {@link TeamInfo} to be added
+	 * @param partyprof the party with profile to be added
 	 * @return new modified SessionSettings object
 	 */
-	SessionSettings with(TeamInfo partyprofteam);
-
-	/**
-	 * 
-	 * @return all parties from all teams, as a flattened ordered list. The
-	 *         order : start with all parties from team 1, then all from team 2,
-	 *         etc. The specific order of the parties from a team depends on the
-	 *         protocol.
-	 */
-	List<PartyWithProfile> getAllParties();
+	public SessionSettings with(PartyWithProfile partyprof);
 
 	/**
 	 * @param logger the logger where the protocol can log events to.
-	 * @return the an initialized and ready to use {@link SessionProtocol} that
-	 *         can handle this Negotiation.
+	 * @return the an initialized and ready to use {@link SessionProtocol} that can
+	 *         handle this Negotiation.
 	 */
 	@Override
-	SessionProtocol getProtocol(Reporter logger);
+	public SessionProtocol getProtocol(Reporter logger);
 
 }
Index: /protocol/src/main/java/geniusweb/protocol/session/SessionState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/SessionState.java	(revision 53)
+++ /protocol/src/main/java/geniusweb/protocol/session/SessionState.java	(revision 1)
@@ -6,12 +6,8 @@
 
 import geniusweb.actions.Action;
-import geniusweb.inform.Agreements;
+import geniusweb.issuevalue.Bid;
 import geniusweb.progress.Progress;
 import geniusweb.protocol.NegoState;
-import geniusweb.protocol.session.amop.AMOPState;
-import geniusweb.protocol.session.learn.LearnState;
-import geniusweb.protocol.session.mopac.MOPACState;
 import geniusweb.protocol.session.saop.SAOPState;
-import geniusweb.protocol.session.shaop.SHAOPState;
 
 /**
@@ -19,9 +15,15 @@
  * and the parties currently connected. <br>
  * The state checks if transitions (Actions from the party) are following the
- * protocol, and thus implement most of the protocol . <br>
+ * protocol, and thus implement most of the protocol . See
+ * {@link #with(geniusweb.actions.PartyId, Action)}. <br>
+ * 
+ * Use {@link #with(geniusweb.actions.PartyId, Action)} and
+ * {@link #with(geniusweb.actions.PartyId, tudelft.utilities.connection.Connection)}
+ * to create a new state <br>
+ * 
  * 
  * If protocol errors occur, these should be stored in the state and the state
- * should become {@link #isFinal(long)}. Throwing should happen only in case of
- * a bug.<br>
+ * should become {@link #isFinal()}. Throwing should happen only in case of a
+ * bug.<br>
  * 
  * Implementations should be immutable (to ensure thread safety, testability
@@ -31,9 +33,6 @@
  * the protocol. As uaual, mark non-serializable fields as transient.
  */
-@JsonSubTypes({ @JsonSubTypes.Type(value = SAOPState.class),
-		@JsonSubTypes.Type(value = SHAOPState.class),
-		@JsonSubTypes.Type(value = AMOPState.class),
-		@JsonSubTypes.Type(value = MOPACState.class),
-		@JsonSubTypes.Type(value = LearnState.class) })
+@JsonSubTypes({ @JsonSubTypes.Type(value = SAOPState.class) })
+
 public interface SessionState extends NegoState {
 
@@ -44,6 +43,5 @@
 	 * 
 	 * @return unmodifyable list of actions done so far, in the order in which
-	 *         they arrived. List of list allows implementations to add some
-	 *         extra structure to the actions, eg one list per phase
+	 *         they arrived.
 	 */
 	List<Action> getActions();
@@ -60,8 +58,8 @@
 	/**
 	 * 
-	 * @return the current standing {@link Agreements}. An agreement does not
-	 *         necessarily mean {@link #isFinal(long)}.
+	 * @return the current standing agreement, or null if there is no agreement
+	 *         at this point. An agreement does not necessarily mean
+	 *         {@link #isFinal()}.
 	 */
-	Agreements getAgreements();
-
+	Bid getAgreement();
 }
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java	(revision 53)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java	(revision 1)
@@ -2,7 +2,4 @@
 
 import java.io.IOException;
-import java.sql.Date;
-import java.text.SimpleDateFormat;
-import java.util.Collections;
 import java.util.List;
 import java.util.Timer;
@@ -16,19 +13,17 @@
 import geniusweb.deadline.Deadline;
 import geniusweb.events.ProtocolEvent;
-import geniusweb.inform.ActionDone;
-import geniusweb.inform.Finished;
-import geniusweb.inform.Inform;
-import geniusweb.inform.Settings;
-import geniusweb.inform.YourTurn;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Finished;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.party.inform.YourTurn;
 import geniusweb.progress.ProgressFactory;
 import geniusweb.protocol.CurrentNegoState;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.protocol.partyconnection.ConnectionWithParty;
+import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionSettings;
 import geniusweb.protocol.session.SessionState;
-import geniusweb.references.Parameters;
 import geniusweb.references.PartyWithProfile;
 import geniusweb.references.ProfileRef;
@@ -40,11 +35,11 @@
 
 /**
- * The protocol runs as follows
+ * 
+ * All parties are first sent the {@link SessionSettings}. Only parties
+ * specified initially in the settings do participate.
  * <ol>
- * <li>The protocol tries to start all parties. If not all parties start, the
+ * The protocol tries to start all parties. If not all parties start, the
  * parties are freed up and another attempt is done to start all parties some
  * time later.
- * <li>All parties are sent the {@link SessionSettings}. Only parties specified
- * initially in the settings do participate.
  * <li>The session deadline clock now starts ticking.
  * <li>All parties are sent their settings.
@@ -63,24 +58,25 @@
  * the protocol.
  * <p>
- * Thread safe: all entry points are synchronized.
+ * Threadsafe: all entrypoints are synhronized.
  */
 public class SAOP extends DefaultListenable<ProtocolEvent>
 		implements SessionProtocol {
-	public static final int TIME_MARGIN = 20;// ms extra delay after deadline
-	public static final int MINDURATION = 100;
-	public static final int MIN_SLEEP_TIME = 1000;
-	public static final int MAX_SLEEP_TIME = 60000;
+	private static final int TIME_MARGIN = 20;// ms extra delay after deadline
+	private static final int MINDURATION = 100;
+	private static final int MIN_SLEEP_TIME = 1000;
+	private static final int MAX_SLEEP_TIME = 60000;
 	private static final ProtocolRef SAOP = new ProtocolRef("SAOP");
 	private final Reporter log;
 
-	// these 4 variables are why protocols are so complex.
 	private SAOPState state = null; // mutable!
 	private volatile AtomicBoolean isFinishedInfoSent = new AtomicBoolean(
 			false);
 	private volatile Timer deadlinetimer = null;
-	private volatile ProtocolToPartyConnections conns;
-
-	public SAOP(SAOPState state, Reporter logger,
-			ProtocolToPartyConnections connects) {
+
+	/**
+	 * 
+	 * @param state normally the initial state coming from SAOPSettings
+	 */
+	public SAOP(SAOPState state, Reporter logger) {
 		if (state == null) {
 			throw new NullPointerException("state must be not null");
@@ -92,20 +88,9 @@
 		this.log = logger;
 		this.state = state;
-		this.conns = connects;
-	}
-
-	/**
-	 * 
-	 * @param state  normally the initial state coming from SAOPSettings
-	 * @param logger the Reporter to log to
-	 */
-	public SAOP(SAOPState state, Reporter logger) {
-		this(state, logger,
-				new ProtocolToPartyConnections(Collections.emptyList()));
 	}
 
 	@Override
 	public synchronized void start(
-			ProtocolToPartyConnFactory connectionfactory) {
+			ConnectionWithPartyFactory connectionfactory) {
 
 		try {
@@ -114,5 +99,5 @@
 			setupParties();
 			nextTurn();
-		} catch (Throwable e) {
+		} catch (ProtocolException | IOException | InterruptedException e) {
 			handleError("Failed to start up session", null, e);
 		}
@@ -163,12 +148,11 @@
 	 */
 	protected synchronized void connect(
-			ProtocolToPartyConnFactory connectionfactory)
+			ConnectionWithPartyFactory connectionfactory)
 			throws InterruptedException, IOException {
 		List<PartyWithProfile> participants = state.getSettings()
-				.getAllParties();
+				.getParticipants();
 		List<Reference> parties = participants.stream()
-				.map(parti -> (parti.getParty().getPartyRef()))
-				.collect(Collectors.toList());
-		List<ProtocolToPartyConn> connections = null;
+				.map(parti -> (parti.getParty())).collect(Collectors.toList());
+		List<ConnectionWithParty> connections = null;
 		log.log(Level.INFO, "SAOP connect " + parties);
 		while (connections == null) {
@@ -186,9 +170,5 @@
 		}
 		for (int i = 0; i < participants.size(); i++) {
-			// now we bookkeep the connections ourselves,
-			// and update the state to keep in sync.
-			conns = conns.with(connections.get(i));
-			setState(this.state.with(connections.get(i).getParty(),
-					participants.get(i)));
+			setState(this.state.with(connections.get(i), participants.get(i)));
 		}
 	}
@@ -210,6 +190,4 @@
 							"BUG. Deadline timer has triggered but state is not final");
 				}
-				log.log(Level.INFO,
-						"SAOP deadline reached. Terminating session.");
 				finish();
 			}
@@ -218,8 +196,4 @@
 		// early
 		deadlinetimer.schedule(task, deadline.getDuration() + TIME_MARGIN);
-		log.log(Level.INFO, "SAOP deadline set to "
-				+ new SimpleDateFormat("yyyy/MM/dd HH:mm:ss")
-						.format(new Date(System.currentTimeMillis()
-								+ deadline.getDuration() + TIME_MARGIN)));
 	}
 
@@ -234,14 +208,14 @@
 	 */
 	protected synchronized void setupParties() throws ProtocolException {
-		for (ProtocolToPartyConn conn : conns) {
+		for (ConnectionWithParty conn : state.getConnections()) {
 			conn.addListener(action -> actionRequest(conn, action));
 		}
 
-		for (ProtocolToPartyConn connection : conns) {
+		for (ConnectionWithParty connection : state.getConnections()) {
 			try {
 				sendSettings(connection);
 			} catch (IOException e) {
 				throw new ProtocolException("Failed to initialize",
-						connection.getParty(), e);
+						connection.getParty().getName(), e);
 			}
 		}
@@ -255,10 +229,8 @@
 	 * @throws IOException if party got disconnected
 	 */
-	private synchronized void sendSettings(ProtocolToPartyConn connection)
+	private synchronized void sendSettings(ConnectionWithParty connection)
 			throws IOException {
 		PartyId partyid = connection.getParty();
 		ProfileRef profile = state.getPartyProfiles().get(partyid).getProfile();
-		Parameters params = state.getPartyProfiles().get(partyid).getParty()
-				.getParameters();
 		if (profile == null) {
 			throw new IllegalArgumentException(
@@ -266,5 +238,5 @@
 		}
 		connection.send(new Settings(connection.getParty(), profile, getRef(),
-				state.getProgress(), params));
+				state.getProgress()));
 	}
 
@@ -273,17 +245,12 @@
 	 * Synchronized so that we always handle only 1 action at a time.
 	 * 
-	 * @param partyconn the connection on which the action came in.
+	 * @param partyconn the connection on which the action came in
 	 * @param action    the {@link Action} taken by some party
 	 */
 	protected synchronized void actionRequest(
-			final ProtocolToPartyConn partyconn, final Action action) {
+			final ConnectionWithParty partyconn, final Action action) {
 		if (action == null) {
-			Throwable err = partyconn.getError();
-			if (err == null) {
-				err = new ProtocolException("Party sent a null action",
-						partyconn.getParty());
-			}
-			handleError(partyconn + "Protocol error", partyconn.getParty(),
-					err);
+			handleError("Received null from " + partyconn + ". Closing session",
+					partyconn.getParty().getName(), null);
 			return;
 		}
@@ -292,16 +259,14 @@
 			if (!partyconn.getParty().equals(state.getNextActor())) {
 				// party does not have the turn.
-				throw new ProtocolException(
-						"Party acts without having the turn",
-						partyconn.getParty());
+				throw new ProtocolException(" act without having the turn",
+						partyconn.getParty().getName());
 			}
-			// FIXME? this ignores possible broadcast errors
-			conns.broadcast(new ActionDone(action));
+			state.getConnections().broadcast(new ActionDone(action));
 			setState(state.with(partyconn.getParty(), action));
 			if (!state.isFinal(System.currentTimeMillis()))
 				nextTurn();
-		} catch (Throwable e) {
+		} catch (Exception e) {
 			handleError("failed to handle action " + action,
-					partyconn.getParty(), e);
+					partyconn.getParty().getName(), e);
 		}
 
@@ -313,10 +278,10 @@
 	 * @throws IOException
 	 */
-	synchronized void nextTurn() {
+	private synchronized void nextTurn() {
 		PartyId party = state.getNextActor();
 		try {
-			conns.get(party).send(new YourTurn());
+			state.getConnections().get(party).send(new YourTurn());
 		} catch (IOException e) {
-			handleError("failed to send YourTurn", party, e);
+			handleError("failed to send YourTurn", party.getName(), e);
 		}
 	}
@@ -326,20 +291,14 @@
 	 * 
 	 * @param message The message to attach to the error
-	 * @param party   the party where the error occured. Can be null in
-	 *                exceptional cases.
+	 * @param party   the party where the error occured
 	 * @param e       the exception that occured.
 	 */
 	private synchronized void handleError(final String message,
-			final PartyId party, final Throwable e) {
+			final String party, final Exception e) {
 		if (e instanceof ProtocolException) {
 			setState(state.with((ProtocolException) e));
-
 		} else {
 			setState(state.with(new ProtocolException(message, party, e)));
 		}
-		if (party != null)
-			setState(state.withoutParty(party));
-		log.log(Level.WARNING, "SAOP protocol intercepted error due to party "
-				+ party + ":" + message, e);
 	}
 
@@ -374,12 +333,12 @@
 		if (!isFinishedInfoSent.compareAndSet(false, true))
 			return;
-		Inform finished = new Finished(state.getAgreements());
-		for (ProtocolToPartyConn conn : conns) {
+		Inform finished = new Finished(state.getAgreement());
+		for (ConnectionWithParty conn : state.getConnections()) {
 			sendFinish(conn, finished);
 		}
-		notifyListeners(new CurrentNegoState(state));
-	}
-
-	private void sendFinish(ProtocolToPartyConn connection, Inform finished) {
+		notifyChange(new CurrentNegoState(state));
+	}
+
+	private void sendFinish(ConnectionWithParty connection, Inform finished) {
 		try {
 			connection.send(finished);
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java	(revision 53)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java	(revision 1)
@@ -4,5 +4,4 @@
 import java.util.LinkedList;
 import java.util.List;
-import java.util.stream.Collectors;
 
 import com.fasterxml.jackson.annotation.JsonCreator;
@@ -12,10 +11,9 @@
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionSettings;
-import geniusweb.protocol.session.TeamInfo;
 import geniusweb.references.PartyWithProfile;
 import tudelft.utilities.logging.Reporter;
 
 public class SAOPSettings implements SessionSettings {
-	private final List<TeamInfo> participants;
+	private final List<PartyWithProfile> participants;
 	private final Deadline deadline;
 
@@ -26,9 +24,9 @@
 	 *                     protocol. But SAOP can be initialized with less, for
 	 *                     use in TournamentSettings.
-	 * @param deadline     the deadline of the negotiation
+	 * @param deadline
 	 */
 	@JsonCreator
 	public SAOPSettings(
-			@JsonProperty("participants") List<TeamInfo> participants,
+			@JsonProperty("participants") List<PartyWithProfile> participants,
 			@JsonProperty("deadline") Deadline deadline) {
 		this.participants = participants;
@@ -53,5 +51,5 @@
 
 	@Override
-	public List<TeamInfo> getTeams() {
+	public List<PartyWithProfile> getParticipants() {
 		return Collections.unmodifiableList(participants);
 	}
@@ -62,16 +60,4 @@
 	public Deadline getDeadline() {
 		return deadline;
-	}
-
-	@Override
-	public List<PartyWithProfile> getAllParties() {
-		return participants.stream()
-				.map(particip -> particip.getParties().get(0))
-				.collect(Collectors.toList());
-	}
-
-	@Override
-	public Integer getTeamSize() {
-		return 1;
 	}
 
@@ -115,10 +101,7 @@
 
 	@Override
-	public SessionSettings with(TeamInfo team) {
-		if (team.getSize() != 1)
-			throw new IllegalArgumentException(
-					"Team must be size 1 but found " + team);
-		List<TeamInfo> newparts = new LinkedList<>(participants);
-		newparts.add(team);
+	public SessionSettings with(PartyWithProfile party) {
+		List<PartyWithProfile> newparts = new LinkedList<>(participants);
+		newparts.add(party);
 		return new SAOPSettings(newparts, deadline);
 	}
